from sqlalchemy import create_engine
from urllib import parse
import pandas as pd
import pymysql

#用户输入参数
fault_name='电压采样断线'
cols=str(['时间戳','sn','单体压差','volt_max','volt_min','volt_mean','volt_sigma','mm_volt_cont'])
col_key='mm_volt_cont'
compare=0
threshold_filtre=1

time_steps=12
nbr_features=6
nbr_neurons=5
nbr_class=2
batch_size=100
epochs=5
dropout=0.5
lr=1e-3
activation='softmax'
loss='categorical_crossentropy'

threshold_accuracy=0.95

#数据库配置
host='rm-bp10j10qy42bzy0q77o.mysql.rds.aliyuncs.com'
port=3306
db='qx_cas'
user='qx_algo_rw'
password='qx@123456'

db_res_engine = create_engine(
    "mysql+pymysql://{}:{}@{}:{}/{}?charset=utf8".format(
        user, parse.quote_plus(password), host, port, db
    ))
#mysql = pymysql.connect (host=host, user=user, password=password, port=port, database=db)
input_param=pd.DataFrame({'fault_name':[fault_name],'cols':[cols],'col_key':[col_key],'compare':[compare],'threshold_filtre':[threshold_filtre],
                        'time_steps':[time_steps],'nbr_features':[nbr_features],'nbr_neurons':[nbr_neurons],'nbr_class':[nbr_class],'batch_size':[batch_size],
                        'epochs':[epochs],'dropout':[dropout],'lr':[lr],'activation':[activation],'loss':[loss],'threshold_accuracy':[threshold_accuracy]})
input_param.to_sql("faultclass_input",con=db_res_engine, if_exists="append",index=False)
#mysql.close()